/* SPDX-License-Identifier: GPL-2.0-only */

#include "../panel.h"

struct panel_serializable_data INX_OTA7290D10P = {
	.edid = {
		.ascii_string = "OTA7290D10P",
		.manufacturer_name = "INX",
		.panel_bits_per_color = 8,
		.panel_bits_per_pixel = 24,
		.mode = {
			.pixel_clock = 159420,
			.lvds_dual_channel = 0,
			.refresh = 60,
			.ha = 1200, .hbl = 141, .hso = 80, .hspw = 1,
			.va = 1920, .vbl = 61, .vso = 35, .vspw = 1,
			.phsync = '-', .pvsync = '-',
			.x_mm = 135, .y_mm = 216,
		},
	},
	.init = {
		INIT_DCS_CMD(0xB0, 0x5A),
		INIT_DCS_CMD(0xB1, 0x00),
		INIT_DCS_CMD(0x89, 0x01),
		INIT_DCS_CMD(0x91, 0x17),
		INIT_DCS_CMD(0xB1, 0x03),
		INIT_DCS_CMD(0x2C, 0x28),
		INIT_DCS_CMD(0x00, 0xF1),
		INIT_DCS_CMD(0x01, 0x78),
		INIT_DCS_CMD(0x02, 0x3C),
		INIT_DCS_CMD(0x03, 0x1E),
		INIT_DCS_CMD(0x04, 0x8F),
		INIT_DCS_CMD(0x05, 0x01),
		INIT_DCS_CMD(0x06, 0x00),
		INIT_DCS_CMD(0x07, 0x00),
		INIT_DCS_CMD(0x08, 0x00),
		INIT_DCS_CMD(0x09, 0x00),
		INIT_DCS_CMD(0x0A, 0x01),
		INIT_DCS_CMD(0x0B, 0x3C),
		INIT_DCS_CMD(0x0C, 0x00),
		INIT_DCS_CMD(0x0D, 0x00),
		INIT_DCS_CMD(0x0E, 0x24),
		INIT_DCS_CMD(0x0F, 0x1C),
		INIT_DCS_CMD(0x10, 0xC8),
		INIT_DCS_CMD(0x11, 0x60),
		INIT_DCS_CMD(0x12, 0x70),
		INIT_DCS_CMD(0x13, 0x01),
		INIT_DCS_CMD(0x14, 0xE3),
		INIT_DCS_CMD(0x15, 0xFF),
		INIT_DCS_CMD(0x16, 0x3D),
		INIT_DCS_CMD(0x17, 0x0E),
		INIT_DCS_CMD(0x18, 0x01),
		INIT_DCS_CMD(0x19, 0x00),
		INIT_DCS_CMD(0x1A, 0x00),
		INIT_DCS_CMD(0x1B, 0xFC),
		INIT_DCS_CMD(0x1C, 0x0B),
		INIT_DCS_CMD(0x1D, 0xA0),
		INIT_DCS_CMD(0x1E, 0x03),
		INIT_DCS_CMD(0x1F, 0x04),
		INIT_DCS_CMD(0x20, 0x0C),
		INIT_DCS_CMD(0x21, 0x00),
		INIT_DCS_CMD(0x22, 0x04),
		INIT_DCS_CMD(0x23, 0x81),
		INIT_DCS_CMD(0x24, 0x1F),
		INIT_DCS_CMD(0x25, 0x10),
		INIT_DCS_CMD(0x26, 0x9B),
		INIT_DCS_CMD(0x2D, 0x01),
		INIT_DCS_CMD(0x2E, 0x84),
		INIT_DCS_CMD(0x2F, 0x00),
		INIT_DCS_CMD(0x30, 0x02),
		INIT_DCS_CMD(0x31, 0x08),
		INIT_DCS_CMD(0x32, 0x01),
		INIT_DCS_CMD(0x33, 0x1C),
		INIT_DCS_CMD(0x34, 0x70),
		INIT_DCS_CMD(0x35, 0xFF),
		INIT_DCS_CMD(0x36, 0xFF),
		INIT_DCS_CMD(0x37, 0xFF),
		INIT_DCS_CMD(0x38, 0xFF),
		INIT_DCS_CMD(0x39, 0xFF),
		INIT_DCS_CMD(0x3A, 0x05),
		INIT_DCS_CMD(0x3B, 0x00),
		INIT_DCS_CMD(0x3C, 0x00),
		INIT_DCS_CMD(0x3D, 0x00),
		INIT_DCS_CMD(0x3E, 0x0F),
		INIT_DCS_CMD(0x3F, 0xA4),
		INIT_DCS_CMD(0x40, 0x28),
		INIT_DCS_CMD(0x41, 0xFC),
		INIT_DCS_CMD(0x42, 0x01),
		INIT_DCS_CMD(0x43, 0x08),
		INIT_DCS_CMD(0x44, 0x05),
		INIT_DCS_CMD(0x45, 0xF0),
		INIT_DCS_CMD(0x46, 0x01),
		INIT_DCS_CMD(0x47, 0x02),
		INIT_DCS_CMD(0x48, 0x00),
		INIT_DCS_CMD(0x49, 0x58),
		INIT_DCS_CMD(0x4A, 0x00),
		INIT_DCS_CMD(0x4B, 0x05),
		INIT_DCS_CMD(0x4C, 0x03),
		INIT_DCS_CMD(0x4D, 0xD0),
		INIT_DCS_CMD(0x4E, 0x13),
		INIT_DCS_CMD(0x4F, 0xFF),
		INIT_DCS_CMD(0x50, 0x0A),
		INIT_DCS_CMD(0x51, 0x53),
		INIT_DCS_CMD(0x52, 0x26),
		INIT_DCS_CMD(0x53, 0x22),
		INIT_DCS_CMD(0x54, 0x09),
		INIT_DCS_CMD(0x55, 0x22),
		INIT_DCS_CMD(0x56, 0x00),
		INIT_DCS_CMD(0x57, 0x1C),
		INIT_DCS_CMD(0x58, 0x03),
		INIT_DCS_CMD(0x59, 0x3F),
		INIT_DCS_CMD(0x5A, 0x28),
		INIT_DCS_CMD(0x5B, 0x01),
		INIT_DCS_CMD(0x5C, 0xCC),
		INIT_DCS_CMD(0x5D, 0x21),
		INIT_DCS_CMD(0x5E, 0x04),
		INIT_DCS_CMD(0x5F, 0x13),
		INIT_DCS_CMD(0x60, 0x42),
		INIT_DCS_CMD(0x61, 0x08),
		INIT_DCS_CMD(0x62, 0x64),
		INIT_DCS_CMD(0x63, 0xEB),
		INIT_DCS_CMD(0x64, 0x10),
		INIT_DCS_CMD(0x65, 0xA8),
		INIT_DCS_CMD(0x66, 0x84),
		INIT_DCS_CMD(0x67, 0x8E),
		INIT_DCS_CMD(0x68, 0x29),
		INIT_DCS_CMD(0x69, 0x11),
		INIT_DCS_CMD(0x6A, 0x42),
		INIT_DCS_CMD(0x6B, 0x38),
		INIT_DCS_CMD(0x6C, 0x21),
		INIT_DCS_CMD(0x6D, 0x84),
		INIT_DCS_CMD(0x6E, 0x50),
		INIT_DCS_CMD(0x6F, 0xB6),
		INIT_DCS_CMD(0x70, 0x0E),
		INIT_DCS_CMD(0x71, 0xA1),
		INIT_DCS_CMD(0x72, 0xCE),
		INIT_DCS_CMD(0x73, 0xF8),
		INIT_DCS_CMD(0x74, 0xDA),
		INIT_DCS_CMD(0x75, 0x1A),
		INIT_DCS_CMD(0x76, 0x00),
		INIT_DCS_CMD(0x77, 0x00),
		INIT_DCS_CMD(0x78, 0x5F),
		INIT_DCS_CMD(0x79, 0xE0),
		INIT_DCS_CMD(0x7A, 0x01),
		INIT_DCS_CMD(0x7B, 0xFF),
		INIT_DCS_CMD(0x7C, 0xFF),
		INIT_DCS_CMD(0x7D, 0xFF),
		INIT_DCS_CMD(0x7E, 0xFF),
		INIT_DCS_CMD(0x7F, 0xFE),
		INIT_DCS_CMD(0xB1, 0x02),
		INIT_DCS_CMD(0x00, 0xFF),
		INIT_DCS_CMD(0x01, 0x01),
		INIT_DCS_CMD(0x02, 0x00),
		INIT_DCS_CMD(0x03, 0x00),
		INIT_DCS_CMD(0x04, 0x00),
		INIT_DCS_CMD(0x05, 0x00),
		INIT_DCS_CMD(0x06, 0x00),
		INIT_DCS_CMD(0x07, 0x00),
		INIT_DCS_CMD(0x08, 0xC0),
		INIT_DCS_CMD(0x09, 0x00),
		INIT_DCS_CMD(0x0A, 0x00),
		INIT_DCS_CMD(0x0B, 0x04),
		INIT_DCS_CMD(0x0C, 0xE6),
		INIT_DCS_CMD(0x0D, 0x0D),
		INIT_DCS_CMD(0x0F, 0x08),
		INIT_DCS_CMD(0x10, 0xE5),
		INIT_DCS_CMD(0x11, 0xA8),
		INIT_DCS_CMD(0x12, 0xEC),
		INIT_DCS_CMD(0x13, 0x54),
		INIT_DCS_CMD(0x14, 0x5A),
		INIT_DCS_CMD(0x15, 0xD5),
		INIT_DCS_CMD(0x16, 0x23),
		INIT_DCS_CMD(0x17, 0x11),
		INIT_DCS_CMD(0x18, 0x2F),
		INIT_DCS_CMD(0x19, 0x93),
		INIT_DCS_CMD(0x1A, 0xA6),
		INIT_DCS_CMD(0x1B, 0x0F),
		INIT_DCS_CMD(0x1C, 0xFF),
		INIT_DCS_CMD(0x1D, 0xFF),
		INIT_DCS_CMD(0x1E, 0xFF),
		INIT_DCS_CMD(0x1F, 0xFF),
		INIT_DCS_CMD(0x20, 0xFF),
		INIT_DCS_CMD(0x21, 0xFF),
		INIT_DCS_CMD(0x22, 0xFF),
		INIT_DCS_CMD(0x23, 0xFF),
		INIT_DCS_CMD(0x24, 0xFF),
		INIT_DCS_CMD(0x25, 0xFF),
		INIT_DCS_CMD(0x26, 0xFF),
		INIT_DCS_CMD(0x27, 0x1F),
		INIT_DCS_CMD(0x28, 0xC8),
		INIT_DCS_CMD(0x29, 0xFF),
		INIT_DCS_CMD(0x2A, 0xFF),
		INIT_DCS_CMD(0x2B, 0xFF),
		INIT_DCS_CMD(0x2C, 0x07),
		INIT_DCS_CMD(0x2D, 0x03),
		INIT_DCS_CMD(0x33, 0x09),
		INIT_DCS_CMD(0x35, 0x7F),
		INIT_DCS_CMD(0x36, 0x0C),
		INIT_DCS_CMD(0x38, 0x7F),
		INIT_DCS_CMD(0x3A, 0x80),
		INIT_DCS_CMD(0x3B, 0x55),
		INIT_DCS_CMD(0x3C, 0xE2),
		INIT_DCS_CMD(0x3D, 0x32),
		INIT_DCS_CMD(0x3E, 0x00),
		INIT_DCS_CMD(0x3F, 0x58),
		INIT_DCS_CMD(0x40, 0x06),
		INIT_DCS_CMD(0x41, 0x80),
		INIT_DCS_CMD(0x42, 0xCB),
		INIT_DCS_CMD(0x43, 0x2C),
		INIT_DCS_CMD(0x44, 0x61),
		INIT_DCS_CMD(0x45, 0x39),
		INIT_DCS_CMD(0x46, 0x00),
		INIT_DCS_CMD(0x47, 0x00),
		INIT_DCS_CMD(0x48, 0x8B),
		INIT_DCS_CMD(0x49, 0xD2),
		INIT_DCS_CMD(0x4A, 0x01),
		INIT_DCS_CMD(0x4B, 0x00),
		INIT_DCS_CMD(0x4C, 0x10),
		INIT_DCS_CMD(0x4D, 0xC0),
		INIT_DCS_CMD(0x4E, 0x0F),
		INIT_DCS_CMD(0x4F, 0xF1),
		INIT_DCS_CMD(0x50, 0x78),
		INIT_DCS_CMD(0x51, 0x7A),
		INIT_DCS_CMD(0x52, 0x34),
		INIT_DCS_CMD(0x53, 0x99),
		INIT_DCS_CMD(0x54, 0xA2),
		INIT_DCS_CMD(0x55, 0x03),
		INIT_DCS_CMD(0x56, 0x6C),
		INIT_DCS_CMD(0x57, 0x1A),
		INIT_DCS_CMD(0x58, 0x05),
		INIT_DCS_CMD(0x59, 0x30),
		INIT_DCS_CMD(0x5A, 0x1E),
		INIT_DCS_CMD(0x5B, 0x8F),
		INIT_DCS_CMD(0x5C, 0xC7),
		INIT_DCS_CMD(0x5D, 0xE3),
		INIT_DCS_CMD(0x5E, 0xF1),
		INIT_DCS_CMD(0x5F, 0x78),
		INIT_DCS_CMD(0x60, 0x3C),
		INIT_DCS_CMD(0x61, 0x36),
		INIT_DCS_CMD(0x62, 0x1E),
		INIT_DCS_CMD(0x63, 0x1B),
		INIT_DCS_CMD(0x64, 0x8F),
		INIT_DCS_CMD(0x65, 0xC7),
		INIT_DCS_CMD(0x66, 0xE3),
		INIT_DCS_CMD(0x67, 0x31),
		INIT_DCS_CMD(0x68, 0x14),
		INIT_DCS_CMD(0x69, 0x89),
		INIT_DCS_CMD(0x6A, 0x70),
		INIT_DCS_CMD(0x6B, 0x8C),
		INIT_DCS_CMD(0x6C, 0x8D),
		INIT_DCS_CMD(0x6D, 0x8D),
		INIT_DCS_CMD(0x6E, 0x8D),
		INIT_DCS_CMD(0x6F, 0x8D),
		INIT_DCS_CMD(0x70, 0xC7),
		INIT_DCS_CMD(0x71, 0xE3),
		INIT_DCS_CMD(0x72, 0xF1),
		INIT_DCS_CMD(0x73, 0xD8),
		INIT_DCS_CMD(0x74, 0xD8),
		INIT_DCS_CMD(0x75, 0xD8),
		INIT_DCS_CMD(0x76, 0x18),
		INIT_DCS_CMD(0x77, 0x00),
		INIT_DCS_CMD(0x78, 0x00),
		INIT_DCS_CMD(0x79, 0x00),
		INIT_DCS_CMD(0x7A, 0xC6),
		INIT_DCS_CMD(0x7B, 0xC6),
		INIT_DCS_CMD(0x7C, 0xC6),
		INIT_DCS_CMD(0x7D, 0xC6),
		INIT_DCS_CMD(0x7E, 0xC6),
		INIT_DCS_CMD(0x7F, 0xE3),
		INIT_DCS_CMD(0x0B, 0x04),
		INIT_DCS_CMD(0xB1, 0x03),
		INIT_DCS_CMD(0x2C, 0x2C),
		INIT_DCS_CMD(0xB1, 0x00),
		INIT_DCS_CMD(0x89, 0x03),
		INIT_DCS_CMD(0x11),
		INIT_DELAY_CMD(0x78),
		INIT_DCS_CMD(0x29),
		INIT_DELAY_CMD(0x14),
		INIT_END_CMD,
	},
};
