/* SPDX-License-Identifier: GPL-2.0-only */

#include "../panel.h"

struct panel_serializable_data STA_QFH032011_53G = {
	.edid = {
		.ascii_string = "QFH032011-53G",
		.manufacturer_name = "STA",
		.panel_bits_per_color = 8,
		.panel_bits_per_pixel = 24,
		.mode = {
			.pixel_clock = 165731,
			.lvds_dual_channel = 0,
			.refresh = 60,
			.ha = 1200, .hbl = 210, .hso = 100, .hspw = 10,
			.va = 1920, .vbl = 39, .vso = 14, .vspw = 10,
			.phsync = '-', .pvsync = '-',
			.x_mm = 135, .y_mm = 217,
		},
	},
	.orientation = LB_FB_ORIENTATION_LEFT_UP,
	.init = {
		INIT_DCS_CMD(0xB0, 0x01),
		INIT_DCS_CMD(0xC3, 0x4F),
		INIT_DCS_CMD(0xC4, 0x40),
		INIT_DCS_CMD(0xC5, 0x40),
		INIT_DCS_CMD(0xC6, 0x40),
		INIT_DCS_CMD(0xC7, 0x40),
		INIT_DCS_CMD(0xC8, 0x4D),
		INIT_DCS_CMD(0xC9, 0x52),
		INIT_DCS_CMD(0xCA, 0x51),
		INIT_DCS_CMD(0xCD, 0x5D),
		INIT_DCS_CMD(0xCE, 0x5B),
		INIT_DCS_CMD(0xCF, 0x4B),
		INIT_DCS_CMD(0xD0, 0x49),
		INIT_DCS_CMD(0xD1, 0x47),
		INIT_DCS_CMD(0xD2, 0x45),
		INIT_DCS_CMD(0xD3, 0x41),
		INIT_DCS_CMD(0xD7, 0x50),
		INIT_DCS_CMD(0xD8, 0x40),
		INIT_DCS_CMD(0xD9, 0x40),
		INIT_DCS_CMD(0xDA, 0x40),
		INIT_DCS_CMD(0xDB, 0x40),
		INIT_DCS_CMD(0xDC, 0x4E),
		INIT_DCS_CMD(0xDD, 0x52),
		INIT_DCS_CMD(0xDE, 0x51),
		INIT_DCS_CMD(0xE1, 0x5E),
		INIT_DCS_CMD(0xE2, 0x5C),
		INIT_DCS_CMD(0xE3, 0x4C),
		INIT_DCS_CMD(0xE4, 0x4A),
		INIT_DCS_CMD(0xE5, 0x48),
		INIT_DCS_CMD(0xE6, 0x46),
		INIT_DCS_CMD(0xE7, 0x42),
		INIT_DCS_CMD(0xB0, 0x03),
		INIT_DCS_CMD(0xBE, 0x03),
		INIT_DCS_CMD(0xCC, 0x44),
		INIT_DCS_CMD(0xC8, 0x07),
		INIT_DCS_CMD(0xC9, 0x05),
		INIT_DCS_CMD(0xCA, 0x42),
		INIT_DCS_CMD(0xCD, 0x3E),
		INIT_DCS_CMD(0xCF, 0x60),
		INIT_DCS_CMD(0xD2, 0x04),
		INIT_DCS_CMD(0xD3, 0x04),
		INIT_DCS_CMD(0xD4, 0x01),
		INIT_DCS_CMD(0xD5, 0x00),
		INIT_DCS_CMD(0xD6, 0x03),
		INIT_DCS_CMD(0xD7, 0x04),
		INIT_DCS_CMD(0xD9, 0x01),
		INIT_DCS_CMD(0xDB, 0x01),
		INIT_DCS_CMD(0xE4, 0xF0),
		INIT_DCS_CMD(0xE5, 0x0A),
		INIT_DCS_CMD(0xB0, 0x00),
		INIT_DCS_CMD(0xCC, 0x08),
		INIT_DCS_CMD(0xC2, 0x08),
		INIT_DCS_CMD(0xC4, 0x10),
		INIT_DCS_CMD(0xB0, 0x02),
		INIT_DCS_CMD(0xC0, 0x00),
		INIT_DCS_CMD(0xC1, 0x0A),
		INIT_DCS_CMD(0xC2, 0x20),
		INIT_DCS_CMD(0xC3, 0x24),
		INIT_DCS_CMD(0xC4, 0x23),
		INIT_DCS_CMD(0xC5, 0x29),
		INIT_DCS_CMD(0xC6, 0x23),
		INIT_DCS_CMD(0xC7, 0x1C),
		INIT_DCS_CMD(0xC8, 0x19),
		INIT_DCS_CMD(0xC9, 0x17),
		INIT_DCS_CMD(0xCA, 0x17),
		INIT_DCS_CMD(0xCB, 0x18),
		INIT_DCS_CMD(0xCC, 0x1A),
		INIT_DCS_CMD(0xCD, 0x1E),
		INIT_DCS_CMD(0xCE, 0x20),
		INIT_DCS_CMD(0xCF, 0x23),
		INIT_DCS_CMD(0xD0, 0x07),
		INIT_DCS_CMD(0xD1, 0x00),
		INIT_DCS_CMD(0xD2, 0x00),
		INIT_DCS_CMD(0xD3, 0x0A),
		INIT_DCS_CMD(0xD4, 0x13),
		INIT_DCS_CMD(0xD5, 0x1C),
		INIT_DCS_CMD(0xD6, 0x1A),
		INIT_DCS_CMD(0xD7, 0x13),
		INIT_DCS_CMD(0xD8, 0x17),
		INIT_DCS_CMD(0xD9, 0x1C),
		INIT_DCS_CMD(0xDA, 0x19),
		INIT_DCS_CMD(0xDB, 0x17),
		INIT_DCS_CMD(0xDC, 0x17),
		INIT_DCS_CMD(0xDD, 0x18),
		INIT_DCS_CMD(0xDE, 0x1A),
		INIT_DCS_CMD(0xDF, 0x1E),
		INIT_DCS_CMD(0xE0, 0x20),
		INIT_DCS_CMD(0xE1, 0x23),
		INIT_DCS_CMD(0xE2, 0x07),
		INIT_DCS_CMD(0X11),
		INIT_DELAY_CMD(120),
		INIT_DCS_CMD(0X29),
		INIT_DELAY_CMD(50),
		INIT_END_CMD,
	},
};
