/* $NoKeywords:$ */
/**
 * @file
 *
 * AMD Family_14 Microcode patch.
 *
 * Fam14 Microcode Patch rev 0500001A for 5001 or equivalent.
 *
 * @xrefitem bom "File Content Label" "Release Content"
 * @e project:      AGESA
 * @e sub-project:  CPU/FAMILY/0x14
 * @e \$Revision: 37850 $   @e \$Date: 2010-09-13 18:09:57 -0400 (Mon, 13 Sep 2010) $
 *
 */
/*
 *****************************************************************************
 *
 * Copyright (c) 2011, Advanced Micro Devices, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Advanced Micro Devices, Inc. nor the names of
 *       its contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL ADVANCED MICRO DEVICES, INC. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***************************************************************************
 *
 */
/*----------------------------------------------------------------------------------------
 *                             M O D U L E S    U S E D
 *----------------------------------------------------------------------------------------
 */
#include "AGESA.h"
#include "cpuRegisters.h"
#include "cpuEarlyInit.h"

/*----------------------------------------------------------------------------------------
 *                   D E F I N I T I O N S    A N D    M A C R O S
 *----------------------------------------------------------------------------------------
 */

/*----------------------------------------------------------------------------------------
 *                  T Y P E D E F S     A N D     S T R U C T U R E S
 *----------------------------------------------------------------------------------------
 */

// Patch code 0500001A for 5001 and equivalent
CONST MICROCODE_PATCHES ROMDATA CpuF14MicrocodePatch0500001A =
{{
  0x10, 0x20, 0x08, 0x09, 0x1a, 0x00, 0x00, 0x05,
  0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x01, 0x50, 0x00, 0x00, 0x00, 0xaa, 0xaa, 0xaa,
  0x66, 0xb4, 0x7f, 0x31, 0x85, 0x36, 0x47, 0xfa,
  0xa2, 0x3e, 0x1c, 0xb4, 0x9d, 0xaa, 0x69, 0x39,
  0xc4, 0xc0, 0xc6, 0xa7, 0xaf, 0x4a, 0x48, 0xe1,
  0xe4, 0xbe, 0x8a, 0x91, 0x15, 0xfd, 0x1f, 0x89,
  0xd9, 0x17, 0x1e, 0xe0, 0xe5, 0x8d, 0xd1, 0x77,
  0xe1, 0xd6, 0xbc, 0x7b, 0x85, 0x18, 0x61, 0xc0,
  0x94, 0xb7, 0x36, 0x07, 0x19, 0x64, 0x8f, 0x10,
  0xda, 0x1e, 0xf1, 0xf3, 0xe4, 0xe9, 0xc6, 0xbd,
  0x05, 0xe5, 0xb2, 0x5c, 0x8a, 0xdb, 0x35, 0x84,
  0x68, 0x07, 0x15, 0xa1, 0xca, 0xcc, 0x41, 0x3a,
  0xef, 0x18, 0x02, 0x72, 0x71, 0xff, 0x65, 0x6e,
  0x3c, 0x2d, 0x2a, 0xe8, 0x26, 0x00, 0xe1, 0xf8,
  0x8b, 0x4c, 0xe2, 0xbd, 0x1b, 0xc0, 0x83, 0x11,
  0xc5, 0x38, 0x65, 0x4d, 0x65, 0xb7, 0x9d, 0x1f,
  0x5b, 0x46, 0x96, 0x6c, 0x7b, 0xc1, 0x03, 0x59,
  0x1d, 0x0f, 0x6b, 0x0b, 0x2c, 0xfc, 0x96, 0x3f,
  0xf8, 0xc5, 0x76, 0xaf, 0x08, 0xb0, 0x60, 0xc8,
  0xaa, 0x66, 0x99, 0x1f, 0xb1, 0x67, 0x85, 0x2b,
  0x03, 0x06, 0x50, 0x7c, 0x22, 0x7c, 0xa7, 0xb4,
  0x04, 0x58, 0xcc, 0xdf, 0xf1, 0xdc, 0x94, 0x84,
  0x84, 0x06, 0xf7, 0x17, 0xc9, 0x02, 0x75, 0xd6,
  0x03, 0xd3, 0x20, 0x8c, 0x23, 0x5e, 0xfb, 0x76,
  0xf3, 0x74, 0x6b, 0x4d, 0x16, 0x1a, 0x66, 0xb6,
  0xfa, 0x30, 0x5f, 0xea, 0x82, 0xf1, 0x5b, 0x9d,
  0xb0, 0xd2, 0xd6, 0x2c, 0xa7, 0x5f, 0xb0, 0x4b,
  0xfa, 0x27, 0xff, 0xd5, 0x7b, 0xfa, 0x8d, 0x18,
  0xab, 0x96, 0xfc, 0x42, 0xc4, 0x5b, 0x85, 0xbc,
  0x9b, 0xf5, 0x4b, 0x59, 0x0d, 0xc7, 0x88, 0xfc,
  0xc0, 0x6e, 0xac, 0xe5, 0xe2, 0xa3, 0x14, 0x44,
  0xf8, 0xb2, 0x8a, 0xe9, 0x9d, 0x75, 0xe2, 0xdc,
  0xf1, 0x3b, 0x18, 0xe9, 0x17, 0x9a, 0x59, 0x55,
  0x28, 0xf3, 0x84, 0xcc, 0xf2, 0x08, 0x6e, 0xe0,
  0x94, 0xd9, 0x88, 0x3d, 0x3a, 0xf0, 0xa2, 0xdb,
  0xa2, 0x58, 0xbe, 0x7c, 0x6e, 0x26, 0xd6, 0x2d,
  0xba, 0x09, 0xba, 0xf8, 0xba, 0x28, 0xf9, 0xff,
  0x71, 0xd3, 0xb4, 0xd7, 0x31, 0x31, 0xd4, 0x8d,
  0xcc, 0x44, 0xcc, 0xb8, 0xed, 0xc7, 0x83, 0x97,
  0x04, 0x88, 0x05, 0xb8, 0x5b, 0x27, 0x6b, 0xef,
  0xe4, 0x5d, 0x03, 0xac, 0x95, 0x05, 0x17, 0x79,
  0x0b, 0xe9, 0xbe, 0xaf, 0x25, 0x4a, 0x3b, 0xf2,
  0x09, 0xd9, 0x83, 0x17, 0x4f, 0x95, 0x11, 0x17,
  0xf5, 0xa4, 0xa6, 0x3e, 0xb8, 0x71, 0x9e, 0x38,
  0x86, 0xc8, 0x97, 0x7b, 0x19, 0xab, 0xd5, 0xec,
  0xc3, 0x99, 0xe2, 0x95, 0x97, 0xbd, 0x93, 0xd0,
  0x1b, 0x76, 0xc4, 0x86, 0x14, 0x58, 0xbf, 0x0b,
  0x14, 0x9d, 0x04, 0x64, 0xa8, 0xa6, 0xaf, 0x69,
  0x3b, 0xe7, 0x37, 0xed, 0x19, 0xaf, 0x28, 0x2b,
  0xff, 0x36, 0xbd, 0x72, 0xf1, 0x2b, 0x06, 0x7f,
  0xe9, 0xae, 0x5e, 0xa0, 0xe3, 0x0d, 0x1e, 0x64,
  0x06, 0xa8, 0x24, 0x99, 0x2e, 0x7a, 0x41, 0x94,
  0x77, 0x4a, 0x17, 0x93, 0x04, 0xd6, 0x2e, 0x86,
  0x7a, 0x24, 0x05, 0x87, 0x18, 0x17, 0xb6, 0xe8,
  0x41, 0xc2, 0x33, 0xec, 0xb6, 0x42, 0xb2, 0x08,
  0xe5, 0xf2, 0x12, 0x15, 0x6b, 0xc9, 0x55, 0xd4,
  0xce, 0xa4, 0x4e, 0xa5, 0x2f, 0xd2, 0x3b, 0xd1,
  0x08, 0x61, 0x9f, 0xe4, 0x92, 0x1a, 0x84, 0x62,
  0x73, 0x7d, 0x87, 0xb2, 0x4b, 0x3d, 0x07, 0x1c,
  0xad, 0x13, 0x9f, 0xd6, 0xa5, 0x80, 0x90, 0x95,
  0x09, 0xf0, 0x45, 0x04, 0x13, 0xd0, 0x06, 0xc2,
  0x24, 0xd4, 0x0b, 0x39, 0xe7, 0x7b, 0xd7, 0xda,
  0x7b, 0x88, 0xe7, 0xcf, 0x53, 0xac, 0x38, 0x11,
  0x2e, 0x01, 0x94, 0x69, 0x5a, 0x04, 0xb4, 0xf5,
  0x1f, 0x7c, 0x44, 0x7a, 0x3e, 0x73, 0x8c, 0x38,
  0xcf, 0xf2, 0xd3, 0xf6, 0x3f, 0x5a, 0x76, 0xd3,
  0x5b, 0x2e, 0x9f, 0xb3, 0xe7, 0x93, 0x11, 0x05,
  0x55, 0x14, 0x8d, 0xc1, 0x6e, 0x36, 0x6e, 0xa3,
  0xa0, 0x0b, 0xe1, 0x48, 0x7f, 0x48, 0x80, 0x21,
  0x59, 0x00, 0x86, 0xd9, 0x1a, 0x99, 0x9e, 0xf6,
  0x4d, 0xa0, 0xd7, 0xbe, 0xb0, 0x2b, 0x13, 0x5d,
  0x5b, 0xf3, 0x01, 0x7d, 0xbc, 0x46, 0x99, 0xd9,
  0xb4, 0xdb, 0xc8, 0xd1, 0x21, 0x94, 0x91, 0xdc,
  0x7a, 0x85, 0xaf, 0x74, 0x9e, 0x0b, 0x18, 0x05,
  0xfd, 0xba, 0xac, 0x7a, 0xea, 0xa9, 0x6e, 0x07,
  0x32, 0xf8, 0x1d, 0x0d, 0x7b, 0x18, 0x6f, 0x13,
  0x89, 0x4c, 0xb3, 0x50, 0x5d, 0x8c, 0x81, 0xd5,
  0x2a, 0x6f, 0xf3, 0xa4, 0x93, 0x7c, 0x16, 0xfd,
  0x25, 0xf8, 0x83, 0xc7, 0xd0, 0x21, 0xf9, 0x51,
  0xc5, 0xbb, 0x6a, 0x42, 0xe6, 0xfd, 0x05, 0x7e,
  0xa0, 0x37, 0x93, 0x55, 0x98, 0x8b, 0x30, 0xbd,
  0x62, 0x33, 0x91, 0xe3, 0x44, 0xd6, 0xc5, 0xa4,
  0x17, 0x2d, 0x70, 0x97, 0xaa, 0x02, 0xc3, 0xa4,
  0x09, 0x6f, 0x7f, 0x00, 0xcf, 0xae, 0x5f, 0x25,
  0xf5, 0x5e, 0xca, 0x7b, 0x7c, 0x61, 0x07, 0x1c,
  0xd9, 0x49, 0xa5, 0x9d, 0x42, 0xe4, 0x74, 0x93,
  0xe1, 0x3f, 0x8f, 0xc0, 0xa1, 0x32, 0x1a, 0x83,
  0x06, 0x3a, 0x1b, 0xb2, 0x25, 0x69, 0xec, 0x20,
  0xd5, 0x9b, 0x7a, 0x9f, 0x34, 0xb0, 0x27, 0x23,
  0x20, 0xa0, 0x31, 0xc1, 0x24, 0xd2, 0x8e, 0x34,
  0x1f, 0x7c, 0xd8, 0xc7, 0x75, 0xb1, 0x4c, 0xe8,
  0x87, 0x98, 0xe1, 0xbb, 0x94, 0x55, 0xc3, 0x63,
  0x25, 0x1a, 0xc8, 0xae, 0x0b, 0xf4, 0xd9, 0xb9,
  0xe3, 0xdc, 0x5e, 0x9a, 0xb1, 0x98, 0x89, 0x4c,
  0x2a, 0x09, 0x0e, 0xfa, 0x98, 0x21, 0x87, 0xf3,
  0x58, 0xe0, 0xa9, 0x8a, 0xda, 0xf5, 0xc7, 0x0b,
  0x70, 0xa5, 0x69, 0x0c, 0xe5, 0x38, 0x98, 0x22,
  0xac, 0x05, 0xe4, 0x45, 0x56, 0x77, 0xa5, 0xfe,
  0x34, 0x5b, 0xb9, 0x45, 0x58, 0x1d, 0x95, 0xd2,
  0x62, 0x60, 0x86, 0x88, 0x19, 0x03, 0x2c, 0xee,
  0xd6, 0xc4, 0x32, 0x41, 0x5d, 0xa5, 0x0b, 0x71,
  0xfb, 0x8c, 0x6c, 0xb0, 0xdc, 0x61, 0x67, 0x3d,
  0xfb, 0xb1, 0xec, 0xf1, 0x95, 0xfc, 0x5d, 0x18,
  0x93, 0x76, 0xca, 0x55, 0x2c, 0xdc, 0x8c, 0x87,
  0xf1, 0x00, 0x84, 0xa6, 0x55, 0x91, 0xab, 0xf9,
  0x24, 0xa5, 0x27, 0x55, 0xfb, 0xd4, 0xb4, 0xfd,
  0xac, 0xc9, 0xfe, 0xdb, 0xeb, 0xcc, 0x6f, 0xd4,
  0x92, 0x8a, 0xa9, 0x26, 0x07, 0xfb, 0x4f, 0x53,
  0x3d, 0x89, 0xa8, 0x4c, 0x94, 0x7a, 0xce, 0xec,
  0xd5, 0x4b, 0xef, 0x65, 0xab, 0x65, 0xc0, 0x3b,
  0x28, 0xfe, 0xfb, 0xc9, 0x83, 0x6b, 0xbc, 0x72,
  0x42, 0xf7, 0x78, 0x92, 0x87, 0x76, 0xbe, 0x0c,
  0x42, 0x42, 0x96, 0x18, 0x03, 0x69, 0x16, 0x67,
  0xc6, 0xe7, 0x75, 0xee, 0xb6, 0x1b, 0x85, 0x46,
  0xb4, 0x65, 0x0a, 0x61, 0xbb, 0xb9, 0xb3, 0x37,
  0xf8, 0x35, 0x98, 0x38, 0x5d, 0x93, 0x3d, 0x99,
  0x84, 0x40, 0x9d, 0x66, 0x3e, 0x3b, 0xd0, 0x01,
  0x8a, 0x67, 0x83, 0xce, 0x26, 0x48, 0x76, 0x93,
  0x70, 0xa7, 0xfe, 0x13, 0xee, 0x5a, 0x30, 0x2c,
  0xcc, 0xba, 0xa9, 0xe8, 0x76, 0x88, 0xa7, 0x8e,
  0x78, 0x22, 0xdf, 0xec, 0xc2, 0x68, 0xcf, 0xf4,
  0x29, 0x6d, 0x19, 0x6e, 0x4d, 0xad, 0x35, 0xee,
  0x07, 0xb5, 0xcf, 0x20, 0x80, 0x77, 0xf9, 0xb7,
  0x45, 0x78, 0x63, 0x3a, 0x39, 0x7b, 0x44, 0xec,
  0x82, 0x0e, 0x8f, 0xf2, 0x03, 0xa8, 0xaf, 0x83,
  0x3d, 0x3a, 0xc5, 0x54, 0xfe, 0xc0, 0xf5, 0xf4,
  0x98, 0xf4, 0x8d, 0x96, 0x2a, 0x62, 0xd2, 0xbc,
  0x56, 0x3c, 0xfe, 0x7d, 0x46, 0x7f, 0x21, 0x92,
  0x8d, 0x57, 0x15, 0x3f, 0xff, 0xc7, 0xe4, 0x24,
  0x71, 0x36, 0xe3, 0x25, 0x7d, 0xb3, 0xf7, 0xd1,
  0x18, 0xf5, 0x3e, 0x0e, 0xb3, 0xa3, 0xd8, 0x60,
  0xda, 0xa6, 0x72, 0xc6, 0x84, 0x09, 0x2b, 0xfe,
  0x74, 0x0d, 0x7b, 0x71, 0x40, 0x74, 0x99, 0x2a,
  0xe9, 0xc4, 0x3e, 0x1f, 0xab, 0x22, 0x21, 0x97,
  0xab, 0x93, 0x4a, 0x72, 0x3b, 0x15, 0xd8, 0xc3,
  0x68, 0x3f, 0xd0, 0x7f, 0x21, 0x48, 0x6e, 0xf2,
  0x68, 0x41, 0x16, 0x49, 0x6a, 0x4c, 0xdd, 0xe0,
  0x44, 0xd6, 0x04, 0xc1, 0xc5, 0x4a, 0x3e, 0x06,
  0x2c, 0x6d, 0x30, 0x76, 0x71, 0x33, 0xde, 0x73,
  0x44, 0x96, 0x05, 0xaa, 0x3d, 0x31, 0x55, 0xf7,
  0xdb, 0x17, 0x5f, 0xa1, 0xd0, 0x36, 0x9f, 0xaa,
  0x95, 0x82, 0x46, 0x79, 0x78, 0x77, 0xaf, 0x04,
  0x78, 0x7d, 0xe8, 0x8a, 0x5c, 0x69, 0xe2, 0x88,
  0xce, 0xca, 0x21, 0x18, 0x0d, 0x1b, 0xe7, 0x3c,
  0x14, 0xec, 0x8b, 0xc6, 0x55, 0x30, 0xf1, 0x40,
  0x7f, 0x4e, 0x1d, 0xda, 0x86, 0x81, 0x05, 0x72,
  0x3a, 0x99, 0xad, 0x78, 0xfc, 0x96, 0xcc, 0x0e,
  0x81, 0x0c, 0xed, 0xce, 0x69, 0x14, 0x15, 0xc9,
  0xdd, 0xb5, 0xf7, 0xde, 0xf5, 0x9c, 0xc7, 0xc1,
  0xb9, 0x09, 0x8e, 0xf7, 0xd9, 0xf2, 0x05, 0x02,
  0x36, 0xe9, 0x8d, 0xb4, 0x51, 0x23, 0x78, 0xc2,
  0x2a, 0x2f, 0x27, 0x2e, 0x2e, 0xa1, 0x9f, 0xda,
  0xb1, 0x0d, 0xc0, 0x97, 0x18, 0x65, 0x4e, 0x87,
  0xa6, 0x95, 0xa7, 0xdc, 0x91, 0xfd, 0x10, 0xee,
  0x32, 0x36, 0x23, 0xad, 0x79, 0x66, 0x68, 0x16,
  0x6a, 0x7a, 0x91, 0xe9, 0xb6, 0xd0, 0xf7, 0x38,
  0xc0, 0xa2, 0xca, 0xd4, 0xc0, 0xcd, 0x4a, 0x68,
  0x01, 0x07, 0x8e, 0x8d, 0x82, 0x85, 0xd1, 0x88,
  0x8c, 0x7b, 0xdf, 0x90, 0x9b, 0x28, 0x00, 0xaa,
  0x4d, 0x14, 0x2f, 0x65, 0xd6, 0x90, 0x7a, 0xe0,
  0x10, 0xed, 0xf0, 0x04, 0x80, 0xff, 0x52, 0xb5,
  0xb3, 0x66, 0xae, 0xb2, 0x4c, 0xe0, 0x4f, 0x69,
  0x18, 0xa6, 0x4e, 0x1a, 0x95, 0xd2, 0xf4, 0x26,
  0xba, 0x16, 0xea, 0xb6, 0x51, 0xdc, 0x3f, 0xf2,
  0x29, 0xf8, 0x5b, 0x1a, 0x6e, 0x0a, 0x21, 0xa2,
  0x34, 0x40, 0x8a, 0x58, 0x10, 0xb7, 0xaa, 0xe5,
  0x4b, 0xa9, 0x7a, 0x7c, 0x32, 0x10, 0xdd, 0x74,
  0x32, 0xca, 0x21, 0xfb, 0x92, 0x88, 0x22, 0x29,
  0xdd, 0x51, 0xe9, 0xcc, 0xcb, 0x66, 0x5f, 0xca,
  0x4a, 0x9d, 0xd6, 0x55, 0x0a, 0x5d, 0xe9, 0x6c,
  0x37, 0xba, 0x75, 0x18, 0x7c, 0x00, 0x4a, 0x78,
  0x58, 0x1f, 0xec, 0x47, 0x75, 0x74, 0x21, 0x13,
  0x69, 0x66, 0x44, 0xe8, 0x00, 0x6f, 0x7d, 0xb9,
  0x31, 0xc8, 0xb1, 0xdc, 0xc2, 0x62, 0x52, 0xf1,
  0x20, 0x1d, 0xeb, 0x88, 0x18, 0x65, 0x13, 0x8f,
  0x78, 0xba, 0x5a, 0xb9, 0x2b, 0x6c, 0x80, 0xe0,
  0xa7, 0x5f, 0xb9, 0xec, 0x1b, 0x86, 0x06, 0x8a,
  0xbf, 0x71, 0x44, 0x4f, 0x41, 0x73, 0x32, 0x59,
  0x01, 0x33, 0x54, 0xac, 0x5e, 0xac, 0xc2, 0x0a,
  0xa4, 0xd5, 0xc3, 0x54, 0x05, 0xbf, 0x44, 0xdc,
  0x72, 0x3d, 0xc8, 0x44, 0x6c, 0x80, 0x1f, 0x69,
  0x16, 0x85, 0x65, 0xbc, 0xa1, 0x99, 0x50, 0xd9,
  0x39, 0xa7, 0x7c, 0xac, 0xf1, 0x0c, 0xd7, 0xdc,
  0xe7, 0x2a, 0xe4, 0xf2, 0xa4, 0x6f, 0xf4, 0xe2,
  0xd5, 0x12, 0x36, 0x93, 0xa6, 0xfd, 0xdd, 0xde,
  0x4c, 0x07, 0x11, 0x43, 0x25, 0x31, 0xa7, 0x54,
  0x81, 0x28, 0x27, 0x41, 0x70, 0xd9, 0xb9, 0x4e,
  0xce, 0x45, 0x40, 0xe2, 0xb8, 0xa5, 0x79, 0xf6,
  0x39, 0x8e, 0xf8, 0xae, 0xfe, 0x25, 0x47, 0x8c,
  0xc2, 0x1a, 0xc0, 0x58, 0x45, 0x38, 0x13, 0x3b,
  0xbb, 0x1e, 0x2c, 0xdf, 0xf6, 0x62, 0xb0, 0xe0,
  0x88, 0x26, 0xf1, 0xab, 0xd9, 0xa0, 0x5d, 0x69,
  0x93, 0x72, 0x6c, 0x4a, 0xe0, 0xef, 0x9f, 0x21,
  0xaf, 0x2b, 0x35, 0x2a, 0x27, 0x73, 0x52, 0x3b
}};

/*----------------------------------------------------------------------------------------
 *           P R O T O T Y P E S     O F     L O C A L     F U N C T I O N S
 *----------------------------------------------------------------------------------------
 */

/*----------------------------------------------------------------------------------------
 *                          E X P O R T E D    F U N C T I O N S
 *----------------------------------------------------------------------------------------
 */
